Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/MultiObjectiveTestFunctionProblem.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/MultiObjectiveTestFunctionProblem.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/MultiObjectiveTestFunctionProblem.cs	(revision 16171)
@@ -38,5 +38,5 @@
 
     #region Parameter Properties
-    public IValueParameter<BoolArray> MaximizationParameter {
+    public new IValueParameter<BoolArray> MaximizationParameter {
       get { return (IValueParameter<BoolArray>)Parameters["Maximization"]; }
     }
@@ -53,10 +53,4 @@
       get { return (IValueParameter<IMultiObjectiveTestFunction>)Parameters["TestFunction"]; }
     }
-    public IValueParameter<DoubleArray> ReferencePointParameter {
-      get { return (IValueParameter<DoubleArray>)Parameters["ReferencePoint"]; }
-    }
-    public OptionalValueParameter<DoubleMatrix> BestKnownFrontParameter {
-      get { return (OptionalValueParameter<DoubleMatrix>)Parameters["BestKnownFront"]; }
-    }
 
     #endregion
@@ -64,8 +58,5 @@
     #region Properties
     public override bool[] Maximization {
-      get {
-        if (!Parameters.ContainsKey("Maximization")) return new bool[2];
-        return MaximizationParameter.Value.ToArray();
-      }
+      get{ return Parameters.ContainsKey(MaximizationParameterName) ? MaximizationParameter.Value.CloneAsArray() : new Fonseca().Maximization(2); }
     }
 
@@ -85,12 +76,4 @@
       get { return TestFunctionParameter.Value; }
       set { TestFunctionParameter.Value = value; }
-    }
-    public DoubleArray ReferencePoint {
-      get { return ReferencePointParameter.Value; }
-      set { ReferencePointParameter.Value = value; }
-    }
-    public DoubleMatrix BestKnownFront {
-      get { return BestKnownFrontParameter.Value; }
-      set { BestKnownFrontParameter.Value = value; }
     }
     #endregion
@@ -116,7 +99,5 @@
       Parameters.Add(new FixedValueParameter<IntValue>("Objectives", "The dimensionality of the solution vector (number of objectives).", new IntValue(2)));
       Parameters.Add(new ValueParameter<DoubleMatrix>("Bounds", "The bounds of the solution given as either one line for all variables or a line for each variable. The first column specifies lower bound, the second upper bound.", new DoubleMatrix(new double[,] { { -4, 4 } })));
-      Parameters.Add(new ValueParameter<DoubleArray>("ReferencePoint", "The reference point used for hypervolume calculation."));
       Parameters.Add(new ValueParameter<IMultiObjectiveTestFunction>("TestFunction", "The function that is to be optimized.", new Fonseca()));
-      Parameters.Add(new OptionalValueParameter<DoubleMatrix>("BestKnownFront", "The currently best known Pareto front"));
 
       Encoding.LengthParameter = ProblemSizeParameter;
@@ -138,7 +119,6 @@
     public override void Analyze(Individual[] individuals, double[][] qualities, ResultCollection results, IRandom random) {
       base.Analyze(individuals, qualities, results, random);
-      if (results.ContainsKey("Pareto Front")) {
+      if (results.ContainsKey("Pareto Front")) 
         ((DoubleMatrix)results["Pareto Front"].Value).SortableView = true;
-      }
     }
 
@@ -170,14 +150,16 @@
     #region Events
     private void UpdateParameterValues() {
-      MaximizationParameter.Value = (BoolArray)new BoolArray(TestFunction.Maximization(Objectives)).AsReadOnly();
-
+      Parameters.Remove(MaximizationParameterName);
+      Parameters.Add(new FixedValueParameter<BoolArray>(MaximizationParameterName, "Set to false if the problem should be minimized.", (BoolArray)new BoolArray(TestFunction.Maximization(Objectives)).AsReadOnly()));
+
+      Parameters.Remove(BestKnownFrontParameterName);
       var front = TestFunction.OptimalParetoFront(Objectives);
-      if (front != null) {
-        BestKnownFrontParameter.Value = (DoubleMatrix)Utilities.ToMatrix(front).AsReadOnly();
-      } else BestKnownFrontParameter.Value = null;
-
+      var bkf = front != null ? (DoubleMatrix)Utilities.ToMatrix(front).AsReadOnly() : null;
+      Parameters.Add(new FixedValueParameter<DoubleMatrix>(BestKnownFrontParameterName, "A double matrix representing the best known qualites for this problem (aka points on the Pareto front). Points are to be given in a row-wise fashion.", bkf));
+
+      Parameters.Remove(ReferencePointParameterName);
+      Parameters.Add(new FixedValueParameter<DoubleArray>(ReferencePointParameterName, "The refrence point for hypervolume calculations on this problem", new DoubleArray(TestFunction.ReferencePoint(Objectives))));
 
       BoundsParameter.Value = new DoubleMatrix(TestFunction.Bounds(Objectives));
-      ReferencePointParameter.Value = new DoubleArray(TestFunction.ReferencePoint(Objectives));
     }
 
@@ -196,5 +178,6 @@
       ProblemSize = Math.Max(TestFunction.MinimumSolutionLength, Math.Min(ProblemSize, TestFunction.MaximumSolutionLength));
       Objectives = Math.Max(TestFunction.MinimumObjectives, Math.Min(Objectives, TestFunction.MaximumObjectives));
-      ReferencePointParameter.ActualValue = new DoubleArray(TestFunction.ReferencePoint(Objectives));
+      Parameters.Remove(ReferencePointParameterName);
+      Parameters.Add(new FixedValueParameter<DoubleArray>(ReferencePointParameterName, "The refrence point for hypervolume calculations on this problem", new DoubleArray(TestFunction.ReferencePoint(Objectives))));
       ParameterizeAnalyzers();
       UpdateParameterValues();
@@ -237,9 +220,4 @@
         analyzer.BestKnownFrontParameter.ActualName = BestKnownFrontParameter.Name;
 
-        var crowdingAnalyzer = analyzer as CrowdingAnalyzer;
-        if (crowdingAnalyzer != null) {
-          crowdingAnalyzer.BoundsParameter.ActualName = BoundsParameter.Name;
-        }
-
         var scatterPlotAnalyzer = analyzer as ScatterPlotAnalyzer;
         if (scatterPlotAnalyzer != null) {
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/NonDominatedSelect.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/NonDominatedSelect.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/NonDominatedSelect.cs	(revision 16171)
@@ -25,66 +25,5 @@
 
   public static class NonDominatedSelect {
-    public enum DominationResult { Dominates, IsDominated, IsNonDominated };
-
-    public static IEnumerable<double[]> SelectNonDominatedVectors(IEnumerable<double[]> qualities, bool[] maximization, bool dominateOnEqualQualities) {
-
-      List<double[]> front = new List<double[]>();
-      foreach (double[] row in qualities) {
-        bool insert = true;
-        for (int i = 0; i < front.Count; i++) {
-          DominationResult res = Dominates(front[i], row, maximization, dominateOnEqualQualities);
-          if (res == DominationResult.Dominates) { insert = false; break; }           //Vector domiates Row
-          else if (res == DominationResult.IsDominated) {   //Row dominates Vector
-            front.RemoveAt(i);
-          }
-        }
-        if (insert) {
-          front.Add(row);
-        }
-      }
-
-      return front;
-    }
-
-    public static IEnumerable<double[]> GetDominatingVectors(IEnumerable<double[]> qualities, double[] reference, bool[] maximization, bool dominateOnEqualQualities) {
-      List<double[]> front = new List<double[]>();
-      foreach (double[] vec in qualities) {
-        if (Dominates(vec, reference, maximization, dominateOnEqualQualities) == DominationResult.Dominates) {
-          front.Add(vec);
-        }
-      }
-      return front;
-    }
-
-    public static DominationResult Dominates(double[] left, double[] right, bool[] maximizations, bool dominateOnEqualQualities) {
-      //mkommend Caution: do not use LINQ.SequenceEqual for comparing the two quality arrays (left and right) due to performance reasons
-      if (dominateOnEqualQualities) {
-        var equal = true;
-        for (int i = 0; i < left.Length; i++) {
-          if (left[i] != right[i]) {
-            equal = false;
-            break;
-          }
-        }
-        if (equal) return DominationResult.Dominates;
-      }
-
-      bool leftIsBetter = false, rightIsBetter = false;
-      for (int i = 0; i < left.Length; i++) {
-        if (IsDominated(left[i], right[i], maximizations[i])) rightIsBetter = true;
-        else if (IsDominated(right[i], left[i], maximizations[i])) leftIsBetter = true;
-        if (leftIsBetter && rightIsBetter) break;
-      }
-
-      if (leftIsBetter && !rightIsBetter) return DominationResult.Dominates;
-      if (!leftIsBetter && rightIsBetter) return DominationResult.IsDominated;
-      return DominationResult.IsNonDominated;
-    }
-
-    private static bool IsDominated(double left, double right, bool maximization) {
-      return maximization && left < right
-        || !maximization && left > right;
-    }
-
+    
   }
 }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ.cs	(revision 16171)
@@ -42,6 +42,6 @@
 
     protected override double[] GetReferencePoint(int objectives) {
-      double[] rp = new double[objectives];
-      for (int i = 0; i < objectives; i++) {
+      var rp = new double[objectives];
+      for (var i = 0; i < objectives; i++) {
         rp[i] = 11;
       }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ1.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ1.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ1.cs	(revision 16171)
@@ -48,9 +48,9 @@
         throw new ArgumentException("The dimensionality of the problem(ProblemSize) must be larger than or equal to the number of objectives");
       }
-      double[] res = new double[objectives];
-      int k = r.Length - objectives + 1;
+      var res = new double[objectives];
+      var k = r.Length - objectives + 1;
       double g = 0;
 
-      for (int i = r.Length - k; i < r.Length; i++) {
+      for (var i = r.Length - k; i < r.Length; i++) {
         g += (r[i] - 0.5) * (r[i] - 0.5) - Math.Cos(20.0 * Math.PI * (r[i] - 0.5));
       };
@@ -58,7 +58,7 @@
       g *= 100;
 
-      for (int i = 0; i < objectives; i++) {
+      for (var i = 0; i < objectives; i++) {
         res[i] = 0.5 * (1.0 + g);
-        for (int j = 0; j < objectives - i - 1; ++j)
+        for (var j = 0; j < objectives - i - 1; ++j)
           res[i] *= (r[j]);
         if (i > 0)
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ2.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ2.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ2.cs	(revision 16171)
@@ -48,17 +48,17 @@
       }
 
-      double[] res = new double[objectives];
+      var res = new double[objectives];
 
       //calculate g(Xm)
       double g = 0;
-      for (int i = objectives; i < r.Length; i++) {
-        double d = r[i] - 0.5;
+      for (var i = objectives; i < r.Length; i++) {
+        var d = r[i] - 0.5;
         g += d * d;
       }
 
       //calculating f0...fM-1
-      for (int i = 0; i < objectives; i++) {
-        double f = i == 0 ? 1 : (Math.Sin(r[objectives - i - 1] * Math.PI / 2)) * (1 + g);
-        for (int j = 0; j < objectives - i - 1; j++) {
+      for (var i = 0; i < objectives; i++) {
+        var f = i == 0 ? 1 : (Math.Sin(r[objectives - i - 1] * Math.PI / 2)) * (1 + g);
+        for (var j = 0; j < objectives - i - 1; j++) {
           f *= Math.Cos(r[j] * Math.PI / 2);
         }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ3.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ3.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ3.cs	(revision 16171)
@@ -47,19 +47,19 @@
         throw new ArgumentException("The dimensionality of the problem(ProblemSize) must be larger than or equal to the number of objectives");
       }
-      double[] res = new double[objectives];
+      var res = new double[objectives];
 
       //calculate g(Xm)
       double sum = 0;
-      int length = r.Length - objectives + 1;
-      for (int i = r.Length - length; i < r.Length; i++) {
-        double d = r[i] - 0.5;
+      var length = r.Length - objectives + 1;
+      for (var i = r.Length - length; i < r.Length; i++) {
+        var d = r[i] - 0.5;
         sum += d * d - Math.Cos(20 * Math.PI * d);
       }
-      double g = 100 * (length + sum);
+      var g = 100 * (length + sum);
 
       //calculating f0...fM-1
-      for (int i = 0; i < objectives; i++) {
-        double f = i == 0 ? 1 : (Math.Sin(r[objectives - i - 1] * Math.PI / 2)) * (1 + g);
-        for (int j = 0; j < objectives - i - 1; j++) {
+      for (var i = 0; i < objectives; i++) {
+        var f = i == 0 ? 1 : (Math.Sin(r[objectives - i - 1] * Math.PI / 2)) * (1 + g);
+        for (var j = 0; j < objectives - i - 1; j++) {
           f *= Math.Cos(r[j] * Math.PI / 2);
         }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ4.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ4.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ4.cs	(revision 16171)
@@ -47,17 +47,17 @@
         throw new ArgumentException("The dimensionality of the problem(ProblemSize) must be larger than or equal to the number of objectives");
       }
-      double[] res = new double[objectives];
+      var res = new double[objectives];
 
       //calculate g(Xm)
       double g = 0;
-      for (int i = objectives; i < r.Length; i++) {
-        double d = r[i] - 0.5;
+      for (var i = objectives; i < r.Length; i++) {
+        var d = r[i] - 0.5;
         g += d * d;
       }
 
       //calculating f0...fM-1
-      for (int i = 0; i < objectives; i++) {
-        double f = i == 0 ? 1 : (Math.Sin(Math.Pow(r[objectives - i - 1], 100) * Math.PI / 2)) * (1 + g);
-        for (int j = 0; j < objectives - i - 1; j++) {
+      for (var i = 0; i < objectives; i++) {
+        var f = i == 0 ? 1 : (Math.Sin(Math.Pow(r[objectives - i - 1], 100) * Math.PI / 2)) * (1 + g);
+        for (var j = 0; j < objectives - i - 1; j++) {
           f *= Math.Cos(Math.Pow(r[j], 100) * Math.PI / 2);
         }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ5.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ5.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ5.cs	(revision 16171)
@@ -42,10 +42,10 @@
         throw new ArgumentException("The dimensionality of the problem(ProblemSize) must be larger than or equal to the number of objectives");
       }
-      double[] res = new double[objectives];
+      var res = new double[objectives];
 
       //calculate g(Xm)
       double g = 0;
-      for (int i = objectives; i < r.Length; i++) {
-        double d = r[i] - 0.5;
+      for (var i = objectives; i < r.Length; i++) {
+        var d = r[i] - 0.5;
         g += d * d;
       }
@@ -56,7 +56,7 @@
 
       //calculating f0...fM-1
-      for (int i = 0; i < objectives; i++) {
-        double f = i == 0 ? 1 : (Math.Sin(phi(r[objectives - i - 1]) * Math.PI / 2)) * (1 + g);
-        for (int j = 0; j < objectives - i - 1; j++) {
+      for (var i = 0; i < objectives; i++) {
+        var f = i == 0 ? 1 : (Math.Sin(phi(r[objectives - i - 1]) * Math.PI / 2)) * (1 + g);
+        for (var j = 0; j < objectives - i - 1; j++) {
           f *= Math.Cos(phi(r[j]) * Math.PI / 2);
         }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ6.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ6.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ6.cs	(revision 16171)
@@ -42,9 +42,9 @@
         throw new ArgumentException("The dimensionality of the problem(ProblemSize) must be larger than or equal to the number of objectives");
       }
-      double[] res = new double[objectives];
+      var res = new double[objectives];
 
       //calculate g(Xm)
       double g = 0;
-      for (int i = objectives; i < r.Length; i++) {
+      for (var i = objectives; i < r.Length; i++) {
         g += Math.Pow(r[i], 0.1);
       }
@@ -55,7 +55,7 @@
 
       //calculating f0...fM-1
-      for (int i = 0; i < objectives; i++) {
-        double f = i == 0 ? 1 : (Math.Sin(phi(r[objectives - i - 1]) * Math.PI / 2)) * (1 + g);
-        for (int j = 0; j < objectives - i - 1; j++) {
+      for (var i = 0; i < objectives; i++) {
+        var f = i == 0 ? 1 : (Math.Sin(phi(r[objectives - i - 1]) * Math.PI / 2)) * (1 + g);
+        for (var j = 0; j < objectives - i - 1; j++) {
           f *= Math.Cos(phi(r[j]) * Math.PI / 2);
         }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ7.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ7.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ7.cs	(revision 16171)
@@ -47,9 +47,9 @@
         throw new ArgumentException("The dimensionality of the problem(ProblemSize) must be larger than or equal to the number of objectives");
       }
-      double[] res = new double[objectives];
+      var res = new double[objectives];
 
       //calculate g(Xm)
       double g = 0, length = length = r.Length - objectives + 1;
-      for (int i = objectives; i < r.Length; i++) {
+      for (var i = objectives; i < r.Length; i++) {
         g += r[i];
       }
@@ -58,10 +58,10 @@
 
       //calculating f0...fM-2
-      for (int i = 0; i < objectives - 1; i++) {
+      for (var i = 0; i < objectives - 1; i++) {
         res[i] = r[i];
       }
       //calculate fM-1
       double h = objectives;
-      for (int i = 0; i < objectives - 1; i++) {
+      for (var i = 0; i < objectives - 1; i++) {
         h -= res[i] / (1 + g) * (1 + Math.Sin(3 * Math.PI * res[i]));
       }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ8.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ8.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/DTLZ/DTLZ8.cs	(revision 16171)
@@ -30,6 +30,6 @@
   public class DTLZ8 : DTLZ, IConstrainedTestFunction {
     public static double[] IllegalValue(int size, bool[] maximization) {
-      double[] res = new double[size];
-      for (int i = 0; i < size; i++) {
+      var res = new double[size];
+      for (var i = 0; i < size; i++) {
         res[i] = maximization[i] ? Double.MinValue : Double.MaxValue;
       }
@@ -49,9 +49,9 @@
       double n = r.Length;
       double M = objectives;
-      double ratio = n / M;
-      double[] res = new double[objectives];
-      for (int j = 0; j < objectives; j++) {
+      var ratio = n / M;
+      var res = new double[objectives];
+      for (var j = 0; j < objectives; j++) {
         double sum = 0;
-        for (int i = (int)(j * ratio); i < (j + 1) + ratio; i++) {
+        for (var i = (int)(j * ratio); i < (j + 1) + ratio; i++) {
           sum += r[i];
         }
@@ -59,11 +59,11 @@
         res[j] = sum;
       }
-      for (int j = 0; j < M - 1; j++) {
+      for (var j = 0; j < M - 1; j++) {
         if (res[objectives - 1] + 4 * res[j] - 1 < 0) return IllegalValue(objectives, GetMaximization(objectives));
       }
-      double min = Double.PositiveInfinity;
-      for (int i = 0; i < res.Length - 1; i++) {
-        for (int j = 0; j < i; j++) {
-          double d = res[i] + res[j];
+      var min = Double.PositiveInfinity;
+      for (var i = 0; i < res.Length - 1; i++) {
+        for (var j = 0; j < i; j++) {
+          var d = res[i] + res[j];
           if (min < d) min = d;
         }
@@ -78,10 +78,10 @@
       double n = r.Length;
       double M = objectives;
-      double ratio = n / M;
-      double[] res = new double[objectives];
-      double[] constraints = new double[objectives];
-      for (int j = 0; j < objectives; j++) {
+      var ratio = n / M;
+      var res = new double[objectives];
+      var constraints = new double[objectives];
+      for (var j = 0; j < objectives; j++) {
         double sum = 0;
-        for (int i = (int)(j * ratio); i < (j + 1) + ratio; i++) {
+        for (var i = (int)(j * ratio); i < (j + 1) + ratio; i++) {
           sum += r[i];
         }
@@ -89,16 +89,16 @@
         res[j] = sum;
       }
-      for (int j = 0; j < M - 1; j++) {
-        double d1 = res[objectives - 1] + 4 * res[j] - 1;
+      for (var j = 0; j < M - 1; j++) {
+        var d1 = res[objectives - 1] + 4 * res[j] - 1;
         constraints[j] = d1 < 0 ? -d1 : 0;
       }
-      double min = Double.PositiveInfinity;
-      for (int i = 0; i < res.Length - 1; i++) {
-        for (int j = 0; j < i; j++) {
-          double d2 = res[i] + res[j];
+      var min = Double.PositiveInfinity;
+      for (var i = 0; i < res.Length - 1; i++) {
+        for (var j = 0; j < i; j++) {
+          var d2 = res[i] + res[j];
           if (min < d2) min = d2;
         }
       }
-      double d = 2 * res[objectives - 1] + min - 1;
+      var d = 2 * res[objectives - 1] + min - 1;
       constraints[constraints.Length - 1] = d < 0 ? -d : 0;
       return constraints;
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR.cs	(revision 16171)
@@ -20,6 +20,8 @@
 #endregion
 using System;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -36,6 +38,6 @@
 
     protected override double[] GetReferencePoint(int objectives) {
-      double[] rp = new double[objectives];
-      for (int i = 0; i < objectives; i++) {
+      var rp = new double[objectives];
+      for (var i = 0; i < objectives; i++) {
         rp[i] = 11;
       }
@@ -58,4 +60,7 @@
     protected abstract double G(RealVector y);
 
+    protected override double GetBestKnownHypervolume(int objectives) {
+      return HypervolumeCalculator.CalculateHypervolume(GetOptimalParetoFront(objectives).ToArray(), GetReferencePoint(objectives), GetMaximization(objectives));
+    }
 
     protected double H(double x, RealVector r) {
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR1.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR1.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR1.cs	(revision 16171)
@@ -31,15 +31,11 @@
   public class IHR1 : IHR {
     protected override IEnumerable<double[]> GetOptimalParetoFront(int objectives) {
-      List<double[]> res = new List<double[]>();
-      for (int i = 0; i <= 500; i++) {
-        RealVector r = new RealVector(objectives);
+      var res = new List<double[]>();
+      for (var i = 0; i <= 500; i++) {
+        var r = new RealVector(objectives);
         r[0] = 1 / 500.0 * i;
         res.Add(this.Evaluate(r, objectives));
       }
       return res;
-    }
-
-    protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -64,6 +60,6 @@
 
     protected override double G(RealVector y) {
-      double sum = 0.0;
-      for (int i = 1; i < y.Length; i++) {
+      var sum = 0.0;
+      for (var i = 1; i < y.Length; i++) {
         sum += HG(y[i]);
       }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR2.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR2.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR2.cs	(revision 16171)
@@ -31,7 +31,7 @@
   public class IHR2 : IHR {
     protected override IEnumerable<double[]> GetOptimalParetoFront(int objectives) {
-      List<double[]> res = new List<double[]>();
-      for (int i = 0; i <= 500; i++) {
-        RealVector r = new RealVector(objectives);
+      var res = new List<double[]>();
+      for (var i = 0; i <= 500; i++) {
+        var r = new RealVector(objectives);
         r[0] = 1 / 500.0 * i;
 
@@ -39,8 +39,4 @@
       }
       return res;
-    }
-
-    protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -66,6 +62,6 @@
 
     protected override double G(RealVector y) {
-      double sum = 0.0;
-      for (int i = 1; i < y.Length; i++) {
+      var sum = 0.0;
+      for (var i = 1; i < y.Length; i++) {
         sum += HG(y[i]);
       }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR3.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR3.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR3.cs	(revision 16171)
@@ -21,4 +21,5 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -31,7 +32,7 @@
   public class IHR3 : IHR {
     protected override IEnumerable<double[]> GetOptimalParetoFront(int objectives) {
-      List<double[]> res = new List<double[]>();
-      for (int i = 0; i <= 500; i++) {
-        RealVector r = new RealVector(objectives);
+      var res = new List<double[]>();
+      for (var i = 0; i <= 500; i++) {
+        var r = new RealVector(objectives);
         r[0] = 1 / 500.0 * i;
 
@@ -39,8 +40,4 @@
       }
       return res;
-    }
-
-    protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -66,6 +63,6 @@
 
     protected override double G(RealVector y) {
-      double sum = 0.0;
-      for (int i = 1; i < y.Length; i++) {
+      var sum = 0.0;
+      for (var i = 1; i < y.Length; i++) {
         sum += HG(y[i]);
       }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR4.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR4.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR4.cs	(revision 16171)
@@ -21,4 +21,5 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -31,15 +32,11 @@
   public class IHR4 : IHR {
     protected override IEnumerable<double[]> GetOptimalParetoFront(int objectives) {
-      List<double[]> res = new List<double[]>();
-      for (int i = 0; i <= 500; i++) {
-        RealVector r = new RealVector(objectives);
+      var res = new List<double[]>();
+      for (var i = 0; i <= 500; i++) {
+        var r = new RealVector(objectives);
         r[0] = 1 / 500.0 * i;
         res.Add(this.Evaluate(r, objectives));
       }
       return res;
-    }
-
-    protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -69,6 +66,6 @@
 
     protected override double G(RealVector y) {
-      double sum = 0.0;
-      for (int i = 1; i < y.Length; i++) {
+      var sum = 0.0;
+      for (var i = 1; i < y.Length; i++) {
         sum += y[i] * y[i] - 10 * Math.Cos(4 * Math.PI * y[i]);
       }
